# coding: utf-8

"""
    Taxonomy API

    Use the Taxonomy API to discover the most appropriate eBay categories under which sellers can offer inventory items for sale, and the most likely categories under which buyers can browse or search for items to purchase. In addition, the Taxonomy API provides metadata about the required and recommended category aspects to include in listings, and also has two operations to retrieve parts compatibility information.  # noqa: E501

    OpenAPI spec version: v1.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RelevanceIndicator(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'search_count': 'int'
    }

    attribute_map = {
        'search_count': 'searchCount'
    }

    def __init__(self, search_count=None):  # noqa: E501
        """RelevanceIndicator - a model defined in Swagger"""  # noqa: E501
        self._search_count = None
        self.discriminator = None
        if search_count is not None:
            self.search_count = search_count

    @property
    def search_count(self):
        """Gets the search_count of this RelevanceIndicator.  # noqa: E501

        The number of recent searches (based on 30 days of data) for the aspect.  # noqa: E501

        :return: The search_count of this RelevanceIndicator.  # noqa: E501
        :rtype: int
        """
        return self._search_count

    @search_count.setter
    def search_count(self, search_count):
        """Sets the search_count of this RelevanceIndicator.

        The number of recent searches (based on 30 days of data) for the aspect.  # noqa: E501

        :param search_count: The search_count of this RelevanceIndicator.  # noqa: E501
        :type: int
        """

        self._search_count = search_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RelevanceIndicator, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RelevanceIndicator):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
